#' Peak detection
#' 
#' Find local peaks of a set of values
#' @param x A vector of numbers to examine for the local peaks
#' @return The peaks of the vector of the numbers
#' @export
localMaxima <- function(x) {
  # Use -Inf instead if x is numeric (non-integer)
  y <- diff(c(-.Machine$integer.max, x)) > 0L
  rle(y)$lengths
  y <- cumsum(rle(y)$lengths)
  y <- y[seq.int(1L, length(y), 2L)]
  if (x[[1]] == x[[2]]) {
    y <- y[-1]
  }
  y
}