\name{DTVEM}
\alias{DTVEM-package}
\alias{DTVEM}
\docType{package}
\title{
Differential Time-Varying Effect Model (DTVEM)
The package DTVEM is a package to identify optimal time lags. 
}
\description{
This package is for identifying and modeling optimal time lags using the Differential Time-Varying Effect Model (DTVEM). This package combines exploratory and confirmatory steps to (1) identify optimal time lags of processes predicting themselves or one another (i.e. univariate or multivariate), (2) find lags within data from continuous time or discrete time (note that all final output is in discrete time). 
}
\details{
\tabular{ll}{
Package: \tab DTVEM\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2015-07-10\cr
License: \tab MIT\cr
}
This package identifies optimal time lags for processes predicting themselves or one another. The primary function is LAG (see ?LAG) for help. 
}
\author{
Author: Nicholas Jacobson <njacobson88@gmail.com>
Maintainer: Nicholas Jacobson <njacobson88@gmail.com>
}
\references{
Jacobson, N. C., Chow, S, & Newman, M.G (2015). The Differential Time-Varying Effect Model (DTVEM): A Tool for Diagnosing Optimal Measurement and Modeling Intervals in Intensive Longitudinal Data.
}
\keyword{ package lag differential time time series longitudinal intensive longitudinal data}
\seealso{
}
\examples{
#LAG("X",differntialtimevaryingpredictors=c("X"),outcome=c("X"),data=expppdat,Time="Time",k=8,ID="ID",predictionsend=10,software="OpenMx")
  
}