% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Stage_2_OpenMx.R
\name{OpenMxstage2}
\alias{OpenMxstage2}
\title{Stage 2 OpenMx: State-Space Confirmatory Model}
\usage{
OpenMxstage2(Timelagsdummy = Timelagsdummy,
  predictionstart = predictionstart, predictionsend = predictionsend,
  predictionsinterval = predictionsinterval,
  variablenamesonlysigall = variablenamesonlysigall,
  independentpredictors = independentpredictors, k3 = k3,
  numberofvars = numberofvars,
  OpenMxStartingValues = OpenMxStartingValues,
  ResidualAnalysis = ResidualAnalysis, varnames = varnames,
  outcome = outcome, numberofpeople = numberofpeople)
}
\arguments{
\item{Timelagsdummy}{The Timelagsdummy data frame}

\item{predictionstart}{The differential time value to start with, default is NULL, and the lowest time difference in the time series will be used (use lower value if you're first value if you're interested in a smaller interval prediction) e.g. predictionstart = 1. If this is not specified and using a continuous time model, make sure to set blockdata = TRUE so that it will be automatically chosen. (OPTIONAL)}

\item{predictionsend}{The differential time value to end with. This means how long you want your largest time difference in the study to be (i.e. if you wanted to predict up to allow time predictions up to 24 hours and your time intervals were specified in hours, you would set predictionsend = 24). If this is not specified and using a continuous time model, make sure to set blockdata = TRUE so that it will be automatically chosen. (OPTIONAL)}

\item{predictionsinterval}{The intervals to predict between differential time points. If using discrete time do you want the intervals to be specified every discrete interval, if so set this to 1. If this is not specified and using a continuous time model, make sure to set blockdata = TRUE so that it will be automatically chosen. (OPTIONAL)}

\item{variablenamesonlysigall}{The variables to be included in the confirmatory model}

\item{independentpredictors}{This is whether or not the wide model comparisons should be run independently and combined via stepwise regression with backward selection. This can be useful to reduce the amount of lags included in the confirmatory model.}

\item{k3}{The number of k selection points used in the model for the time spline (NOTE THAT THIS CONTROLS FOR TIME TRENDS OF THE POPULATION)  (see ?choose.k in mgcv package for more details). Default is 3. (OPTIONAL)}

\item{numberofvars}{This is the number of variables in the model}

\item{OpenMxStartingValues}{Only applies when software = "OpenMx". Specify the starting values for OpenMx. Since OpenMx will 10 different runs before giving up on convergence this does not usually need to be specified. It should mostly only be specified if there is a convergence issue with OpenMx. Default is 0.3.  (OPTIONAL, UNCOMMONLY SPECIFIED)}

\item{ResidualAnalysis}{Only applies when software = "OpenMx". Analyze the residuals of the time series with OpenMx after factoring out the non-linear effect of time (takes time trends into account). Can be run only at the group level (faster), or it can also be run with a random effect splines of time (slower) by setting ResidualAnalysis = "Individual". Default = "Group" (OPTIONAL)}

\item{varnames}{What are the variable names?}

\item{outcome}{what are the outcome variables?}

\item{numberofpeople}{How many people are there?}

\item{...}{A list of variable names used in the function e.g. "X","Y" (REQUIRED)}
}
\value{
The output of this function is: The output from the second stage of DTVEM using the state-space approach
}
\description{
PLEASE USE THE LAG FUNCTION RATHER THAN THIS UNLESS YOU WOULD LIKE TO SPECIFY THIS MANUALLY.
}
